''' ----------------------   Functions importation   ---------------------- '''

# Functions importation
from SelectVehicle import SelectVehicle

''' ---------------------   Dependence consideration   --------------------- '''

def dependence(a, s1, k1, qremain, tmax, q1, S, V, AC, env, sol):
    #Vehicles ID start at 1, but python vectors start at 0
    v1 = k1 - 1 
   
    
    ## If service s1 does not precede any other services, v1 should be freed
    if not S.next[s1]:
        V.used[v1] = False
        
        #If the considered vehicle must follow a services sequence (dollies only)
        if len(V.sequence[v1]) > 0:
            #Dollies can follow 2 different services sequences
            #If the dollies are involved in the 1st services sequence
            if V.currentService[v1] in V.sequence[v1][0]:
                x = V.sequence[v1][0].index(V.currentService[v1])
                #If we are not at the end of the services sequence, 
                #go to the next service of the sequence
                if x < len(V.sequence[v1][0]) - 1:
                    y = x + 1
                    V.currentService[v1] = V.sequence[v1][0][y]
                #Else, dollies can perform any services of its service list
                else:
                    V.currentService[v1] = "any"
            #If the dollies are involved in the 2nd services sequence
            else:
                x = V.sequence[v1][1].index(V.currentService[v1])
                #If we are not at the end of the services sequence, 
                #go to the next service of the sequence
                if x < len(V.sequence[v1][1]) - 1:
                    y = x + 1
                    V.currentService[v1] = V.sequence[v1][1][y]
                #Else, dollies can perform any services of its service list
                else:
                    V.currentService[v1] = "any"
        #If the considered vehicle has no services sequence to follow
        else:
            #It can perform any services of its service list
            V.currentService[v1] = "any"
        
        #If the vehicle v1 is not involved in a service sequence (anymore),
        #it can serve again any compatible AC
        if V.currentService[v1] == "any":
            V.compatibleAC[v1] = V.compatibleAC_init[v1]


    ## If service s1 precedes one or more services
    else:
        #The earliest start time of the services s1 precedes is the end time of service s1
        t2 = tmax
        
        #Handle all the services directly dependent of s1 individually
        for s2 in S.next[s1]:
            #The earliest start time of the services s1 precedes is the end time of service s1
            tsuite2 = t2
            
        
            ## If there is no quantity transfer between s1 and s2 (only a precedence constraint)
            if S.QGlobal[s2] == True:
                #The quantity to serve is the one requested by the AC
                q2 = S.q[s2][a]
                #v1 could be freed
                if V.used[v1] == True:
                    V.used[v1] = False
                    
                    #If the considered vehicle must follow a services sequence (dollies only)
                    if len(V.sequence[v1]) > 0:
                        #Dollies can follow 2 different services sequences
                        #If the dollies are involved in the 1st services sequence
                        if V.currentService[v1] in V.sequence[v1][0]:
                            x = V.sequence[v1][0].index(V.currentService[v1])
                            #If we are not at the end of the services sequence, 
                            #go to the next service of the sequence
                            if x < len(V.sequence[v1][0]) - 1:
                                y = x + 1
                                V.currentService[v1] = V.sequence[v1][0][y]
                            #Else, dollies can perform any services of its service list
                            else:
                                V.currentService[v1] = "any"
                        #If the dollies are involved in the 2nd services sequence
                        else:
                            x = V.sequence[v1][1].index(V.currentService[v1])
                            #If we are not at the end of the services sequence, 
                            #go to the next service of the sequence
                            if x < len(V.sequence[v1][1]) - 1:
                                y = x + 1
                                V.currentService[v1] = V.sequence[v1][1][y]
                            #Else, dollies can perform any services of its service list
                            else:
                                V.currentService[v1] = "any"
                    #If the considered vehicle has no services sequence to follow
                    else:
                        #It can perform any services of its service list
                        V.currentService[v1] = "any"
                    
                    #If the vehicle v1 is not involved in a service sequence (anymore),
                    #it can serve again any compatible AC
                    if V.currentService[v1] == "any":
                        V.compatibleAC[v1] = V.compatibleAC_init[v1]
            
            
            ## If there is a quantity transfer between s1 and s2 (v1 is unloaded by v2)
            else:
                #Specificity of dollies transport after dollies selection where loading = False
                if s2 == 7 or s2 == 13:
                    q2 = q1
                #The quantity s2 has to serve is equal to v1 current load
                else:
                    q2 = V.maxCap[v1] - V.currentCap[v1]


            ## While v1 i is not completely unloaded
            while q2 > 0:

                #Vehicle selection
                #If service s2 can be operated by several vehicles at once
                if S.simultaneity[s2] == True:
                    #The selected vehicle can start the service at t2 (no waiting time)
                    k2, load, t_end, t_new = SelectVehicle(a, s2, k1, t2, q2, AC, env, S, V, sol)
                
                #If service s2 cannot be operated by several vehicles at once
                else:
                    #The selected vehicle can start only when the previously selected vehicle 
                    #for service s2 has finished its task (cannot start before tsuite2)
                    k2, load, t_end, t_new = SelectVehicle(a, s2, k1, tsuite2, q2, AC, env, S, V, sol)
                
                #Vehicles ID start at 1, but python vectors start at 0
                v2 = k2 - 1 
               
                #Update the quantity that remains to be served
                q2 -= load

                #Update the time at which v1 becomes available again
                if S.QGlobal[s2] == False:
                    V.available[v1] = max(t_new, V.available[v1])
                    #If there is an effective quantity transfer between v1 and v2
                    if S.loading[s2] == True:
                        #Update v1 current capacity
                        V.currentCap[v1] += load

                #Update time parameters
                tmax = max(t_end, tmax)
                tsuite2 = t_end
                sol.EndTime[a][s2] = t_end
               
                #If v1 is transported by v2, update the current position of v1 and its current service 
                #(as only dollies can be transported by other vehicles)
                if S.transpVehicle[s2] == True:
                    V.currentPos[v1] = V.currentPos[v2]
                    
                    #If the considered vehicle must follow a services sequence (dollies only)
                    if len(V.sequence[v1]) > 0:
                        #Dollies can follow 2 different services sequences
                        #If the dollies are involved in the 1st services sequence
                        if V.currentService[v1] in V.sequence[v1][0]:
                            x = V.sequence[v1][0].index(V.currentService[v1])
                            #If we are not at the end of the services sequence, 
                            #go to the next service of the sequence
                            if x < len(V.sequence[v1][0]) - 1:
                                y = x + 1
                                V.currentService[v1] = V.sequence[v1][0][y]
                            #Else, dollies can perform any services of its service list
                            else:
                                V.currentService[v1] = "any"
                        #If the dollies are involved in the 2nd services sequence
                        else:
                            x = V.sequence[v1][1].index(V.currentService[v1])
                            #If we are not at the end of the services sequence, 
                            #go to the next service of the sequence
                            if x < len(V.sequence[v1][1]) - 1:
                                y = x + 1
                                V.currentService[v1] = V.sequence[v1][1][y]
                            #Else, dollies can perform any services of its service list
                            else:
                                V.currentService[v1] = "any"
                    #If the considered vehicle has no services sequence to follow
                    else:
                        #It can perform any services of its service list
                        V.currentService[v1] = "any"
                    
                #The next service of the transfer chain can start only when v2 is full 
                #or when it is the last units to perform
                if (S.QGlobal[s2] == True and q2 == 0) or V.currentCap[v2] == 0 or (S.QGlobal[s2] == False and qremain == load):
                    t_end, qremain = dependence(a, s2, k2, qremain, t_end, load, S, V, AC, env, sol)
                    tmax = max(t_end, tmax)
                
                #To take into account the last units in any case
                if S.QGlobal[s2] == False and not S.next[s2]:
                    qremain -= load


            ## Allow v1 to start another service
            if S.QGlobal[s2] == False:
                if V.used[v1] == True:
                    V.used[v1] = False
                    
                    #If the considered vehicle must follow a services sequence (dollies only)
                    if len(V.sequence[v1]) > 0:
                        #Dollies can follow 2 different services sequences
                        #If the dollies are involved in the 1st services sequence
                        if V.currentService[v1] in V.sequence[v1][0]:
                            x = V.sequence[v1][0].index(V.currentService[v1])
                            #If we are not at the end of the services sequence, 
                            #go to the next service of the sequence
                            if x < len(V.sequence[v1][0]) - 1:
                                y = x + 1
                                V.currentService[v1] = V.sequence[v1][0][y]
                            #Else, dollies can perform any services of its service list
                            else:
                                V.currentService[v1] = "any"
                        #If the dollies are involved in the 2nd services sequence
                        else:
                            x = V.sequence[v1][1].index(V.currentService[v1])
                            #If we are not at the end of the services sequence, 
                            #go to the next service of the sequence
                            if x < len(V.sequence[v1][1]) - 1:
                                y = x + 1
                                V.currentService[v1] = V.sequence[v1][1][y]
                            #Else, dollies can perform any services of its service list
                            else:
                                V.currentService[v1] = "any"
                    #If the considered vehicle has no services sequence to follow
                    else:
                        #It can perform any services of its service list
                        V.currentService[v1] = "any"
                    
                    #If the vehicle v1 is not involved in a service sequence (anymore),
                    #it can serve again any compatible AC
                    if V.currentService[v1] == "any":
                        V.compatibleAC[v1] = V.compatibleAC_init[v1]
                    
    return tmax, qremain
